'Compilable Example:
#Compile Exe "gbhtmlnavigator.exe"
#Dim All

#Debug Error On
#Debug Display On

%Unicode = 1
%UseWebBrowser = 1            '
#Include "win32api.inc"   'Jose Roca includes
#Include Once "CWindow.inc"

#Resource Manifest, 1, "files\xptheme.xml"
#Resource Icon logo "images\gbhtmlnavigator.ico"
#Resource Icon xhelp "images\help.ico"
#Resource Icon xsettings "images\settings.ico"
#Resource Icon xnext "images\next.ico"
#Resource Icon xprevious "images\previous.ico"
#Resource Icon xnexts "images\nexts.ico"
#Resource Icon xpreviouss "images\previouss.ico"
#Resource Icon xhighlight "images\highlight.ico"
#Resource Icon xopen "images\open.ico"
#Resource Icon xmatch "images\match.ico"
#Resource Icon xsearch "images\search.ico"
#Resource Icon xwhole "images\whole.ico"
#Resource Icon xtop "images\top.ico"
#Resource Icon xbottom "images\bottom.ico"
#Resource Icon xexact "images\exact.ico"
#Resource Icon xcopy "images\copy.ico"
#Resource Icon xcopyv "images\copyv.ico"

%GoNext = 1
%GoPrevious = -1

Enum Equates Singular
   IDC_Browser  = 500
   IDC_Toolbar
   IDC_StatusBar
   IDC_SearchString
   IDC_SearchStringLabel
   IDC_FileName
   IDC_FileNameLabel

   IDT_Open
   IDT_Copy
   IDT_CopyAll
   IDT_GoToTop
   IDT_Search
   IDT_ExactString
   IDT_NextC
   IDT_PreviousC
   IDT_NextS
   IDT_PreviousS
   IDT_Top
   IDT_Bottom
   IDT_Highlight
   IDT_Settings
   IDT_MatchCase
   IDT_WholeWords
   IDT_Help

   IDM_Sep
   IDM_Search
   IDM_Next
   IDM_Previous
   IDM_Highlight
   IDM_UnHighLight
   IDM_Copy
   IDM_Erase
   IDM_Reload
   IDM_CustomMenu
   IDM_CopyAll
   IDM_GoTo
End Enum

Global hDlg,hToolbar,hBrowser, hPopupBrowser,ghHook As Dword
Global hPopupSettings As Dword
Global CustomMenu, ExactString, Highlight, MatchCase, WholeWords, NextElement, LastChapter As Long
Global FileName, SearchString As WStringZ * %Max_Path
Global pWindow As IWindow, pWBEvents As DWebBrowserEvents2Impl

Function PBMain
   Dialog New Pixels, 0, "gbHTMLNavigator", , , 600, 400, %WS_OverlappedWindow To hDlg
   Dialog Set Icon hDlg, "logo"

   CreateToolbar
   Control Add Label, hDlg, %IDC_SearchStringLabel, "Highlight Terms:", 10,60,80,20
   Control Add TextBox, hDlg, %IDC_SearchString, "Chapter", 95,60,125,20
   Control Add Label, hDlg, %IDC_FileNameLabel, "Document:", 230,60,55,20
   Control Add TextBox, hDlg, %IDC_FileName, "", 290,60,250,20

   pWindow = Class "CWindow"
   pWBEvents = Class "CDWebBrowserEvents2"
   hBrowser = pWindow.AddWebBrowserControl(hDlg, %IDC_Browser, "", pWBEvents, 0, 90, 600,350)

   Control Add Statusbar, hDlg, %IDC_StatusBar, "",0,0,0,0
   Dialog Show Modal hDlg, Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local iResult As Long, temp$, pIWebBrowser2 As IWebBrowser2
   Local rc As Rect, P As TooltipText Ptr, nmtb As TBNotify Ptr
   Select Case CbMsg
      Case %WM_InitDialog
         NextElement = 0
         LastChapter = 0
         BuildAcceleratorTable
         CreateContextMenus
         Settings_ini "get"
         Control Set Text hDlg, %IDC_FileName, FileName
         DisplayFileInBrowser
         SetMenusAndToolbar
         If Highlight Then Dialog Post hDlg, %WM_User+500, %Null, %Null

      Case %WM_User+500
         pIWebBrowser2 = OC_GetDispatch(hBrowser) 'reference to webbrowser control default interface
         Do
            AfxPumpMessages
            If pIWebBrowser2.ReadyState = %ReadyState_Complete Then Exit Do
         Loop
         HighlightTerms

      Case %WM_Destroy
         Settings_ini "save"

      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDM_Reload
               Control Get Text hDlg, %IDC_FileName To FileName
               DisplayFileInBrowser

            Case %IDM_Erase
               ClearBrowser

            Case %IdOk
               Select Case GetFocus
                  Case GetDlgItem(hDlg,%IDC_SearchString)
                     Highlight = 1
                     HighlightTerms
                     SetMenusAndToolbar
                  Case GetDlgItem(hDlg,%IDC_FileName)
                      Control Get Text hDlg, %IDC_FileName To temp$
                      If IsFile(temp$) Then
                         FileName = temp$
                         DisplayFileInBrowser
                      End If

               End Select
            Case %IDT_Copy       : CopySelection
            Case %IDT_CopyAll    : CopyAll
            Case %IDT_Open       : SelectFile
            Case %IDT_Bottom     : GoToPosition(0,100000)
            Case %IDT_Top        : GoToPosition(0,0)
            Case %IDT_Search     : OpenSearchDialog
            Case %IDT_NextC      : GoToElement %GoNext, "h2"
            Case %IDT_PreviousC  : GoToElement %GoPrevious, "h2"
            Case %IDT_NextS      : GoToElement %GoNext, "h3"
            Case %IDT_PreviousS  : GoToElement %GoPrevious, "h3"

            Case %IDM_CopyAll    : CopyAll

            Case %IDM_CustomMenu, %IDT_Settings
               CustomMenu = CustomMenu Xor 1
               SetMenusAndToolbar
               Control Get Text hDlg, %IDC_FileName To FileName

               Control Kill hDlg, %IDC_Browser
               pWindow = Class "CWindow"
               pWBEvents = Class "CDWebBrowserEvents2"
               hBrowser = pWindow.AddWebBrowserControl(hDlg, %IDC_Browser, "", pWBEvents, 0, 90, 600,350)
               ResizeWindow
               DisplayFileInBrowser

            Case %IDT_ExactString
               ExactString = ExactString Xor 1
               SetMenusandToolbar

            Case %IDT_Highlight
               Highlight = Highlight Xor 1
               HighlightTerms
               SetMenusandToolbar

            Case %IDT_MatchCase
               If Highlight Then
                  're-highlight to new setting
                  HighLight = 0 : HighlightTerms
                  MatchCase = MatchCase Xor 1
                  pIWebBrowser2 = OC_GetDispatch(hBrowser) 'reference to webbrowser control default interface
                  Do
                     AfxPumpMessages
                     If pIWebBrowser2.ReadyState = %ReadyState_Complete Then Exit Do
                  Loop
                  HighLight = 1 : HighlightTerms
               Else
                  MatchCase = MatchCase Xor 1
               End If
               SetMenusAndToolbar

            Case %IDT_WholeWords
               If Highlight Then
                  're-highlight to new setting
                  HighLight = 0 : HighlightTerms
                  WholeWords = WholeWords Xor 1
                  pIWebBrowser2 = OC_GetDispatch(hBrowser) 'reference to webbrowser control default interface
                  Do
                     AfxPumpMessages
                     If pIWebBrowser2.ReadyState = %ReadyState_Complete Then Exit Do
                  Loop
                  HighLight = 1 : HighlightTerms
               Else
                  WholeWords = WholeWords Xor 1
               End If
               SetMenusAndToolbar

            Case %IDT_Settings
            Case %IDT_Help
                 temp$ = "http://www.garybeene.com/sw/gbhtmlnavigator.htm"
                 iResult = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)

            Case %IDM_GoTo : GoToChapter
            Case %IDM_UnHighLight : UnHighlightAll
         End Select

      Case %WM_Notify
           nmtb = Cb.LParam
           Select Case @nmtb.hdr.Code
              Case %TBN_DROPDOWN
                 Select Case @nmtb.iItem
                    Case %IDT_Settings
                       Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                       Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                       Call TrackPopupMenu (hPopUpSettings, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %NULL)
                 End Select
           End Select

           Select Case Cb.NmId
               Case %IDT_Open To %IDT_Help
                   Select Case Cb.NmCode
                      Case %TTN_GetDispInfo
                         P = Cb.LParam
                         @P.@lpszText = SetToolTips(Cb.NmId)
                   End Select
           End Select

      Case %WM_Timer

      Case %WM_Size
         If Cb.WParam <> %Size_Minimized Then ResizeWindow
   End Select
End Function

Sub ResizeWindow
   Local w,h As Long
   Dialog Get Client hDlg To w,h
   Control Set Size hDlg, %IDC_Browser, w, h-120
   Control Set Size hDlg, %IDC_FileName, w-300,20
End Sub

Sub BuildAcceleratorTable
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(5)
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F1 : ac(c).cmd  = %IDT_Help          : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_E  : ac(c).cmd  = %IDM_Erase         : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_R  : ac(c).cmd  = %IDM_Reload        : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_F  : ac(c).cmd  = %IDM_Search        : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_G  : ac(c).cmd  = %IDM_GoTo          : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_U  : ac(c).cmd  = %IDM_UnHighLight   : Incr c
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Sub CreateToolbar
    Local hImageList As Dword
    ImageList New Icon 24,24,24,10 To hImageList
    ImageList Add Icon hImageList, "xopen"      '1
    ImageList Add Icon hImageList, "xnext"      '2
    ImageList Add Icon hImageList, "xprevious"  '3
    ImageList Add Icon hImageList, "xhighlight" '4
    ImageList Add Icon hImageList, "xmatch"     '5
    ImageList Add Icon hImageList, "xsettings"  '6
    ImageList Add Icon hImageList, "xhelp"      '7
    ImageList Add Icon hImageList, "xsearch"    '8
    ImageList Add Icon hImageList, "xnexts"     '9
    ImageList Add Icon hImageList, "xpreviouss" '10
    ImageList Add Icon hImageList, "xwhole"     '11
    ImageList Add Icon hImageList, "xtop"       '12
    ImageList Add Icon hImageList, "xbottom"    '13
    ImageList Add Icon hImageList, "xexact"     '14
    ImageList Add Icon hImageList, "xcopy"     '15
    ImageList Add Icon hImageList, "xcopyv"     '16

    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0, %TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
    Control Handle hDlg, %IDC_Toolbar To hToolbar
    SendMessage hToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS

    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0     'default imagelist
    Toolbar Add Button  hDlg, %IDC_Toolbar, 1, %IDT_Open,  %TbStyle_Button, "Open"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 15, %IDT_Copy,  %TbStyle_Button, "Copy"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 16, %IDT_CopyAll,  %TbStyle_Button, "CopyAll"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 4, %IDT_Highlight,  %TbStyle_Check, "Highlight"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 5, %IDT_MatchCase,  %TbStyle_Check, "Match"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 11, %IDT_WholeWords,  %TbStyle_Check, "Word"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 14, %IDT_ExactString,  %TbStyle_Check, "Exact"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 8, %IDT_Search,  %TbStyle_Button, "Search"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 3, %IDT_PreviousC,  %TbStyle_Button, "Previous"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 2, %IDT_NextC,  %TbStyle_Button, "Next"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 10, %IDT_PreviousS,  %TbStyle_Button, "Previous"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 9, %IDT_NextS,  %TbStyle_Button, "Next"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 12, %IDT_Top,  %TbStyle_Button, "Top"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 13, %IDT_Bottom,  %TbStyle_Button, "Bottom"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 6, %IDT_Settings,  %TbStyle_Button Or %TbStyle_DropDown, "Settings"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 7, %IDT_Help,  %TbStyle_Button, "Help"

End Sub

Function SetToolTips(cID As Long) As String
   Select Case cID         'or this:   @P.hdr.idFrom
      Case %IDT_Open       : Function = "Open Select File Dialog"
      Case %IDT_NextC       : Function = "Next Chapter"
      Case %IDT_PreviousC   : Function = "Previous Chapter"
      Case %IDT_NextS       : Function = "Next Section"
      Case %IDT_PreviousS   : Function = "Previous Section"
      Case %IDT_Highlight   : Function = "Highlight Terms"
      Case %IDT_ExactString : Function = "Highlight Exact String"
      Case %IDT_MatchCase   : Function = "Match Case On Highlight"
      Case %IDT_WholeWords  : Function = "Highlight Whole Words Only"
      Case %IDT_Settings    : Function = "Default Settings Button Action"
      Case %IDT_Help        : Function = "Open Online Help"
   End Select
End Function

Sub CreateContextMenus
    Menu New PopUp To hPopupBrowser
    Menu Add String, hPopupBrowser, "Copy All",  %IDM_CopyAll,  %MF_Enabled
    Menu Add String, hPopupBrowser, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hPopupBrowser, "Clear",  %IDM_Erase,  %MF_Enabled
    Menu Add String, hPopupBrowser, "Reload",  %IDM_Reload,  %MF_Enabled

    Menu New PopUp To hPopupSettings
    Menu Add String, hPopupSettings, "Custom Menu", %IDM_CustomMenu, %MF_Enabled
End Sub

Sub SetMenusAndToolbar
   'Toolbar Buttons
      Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Highlight, Highlight * %TBState_Checked Or %TBState_Enabled
      Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_ExactString, ExactString * %TBState_Checked Or %TBState_Enabled
      Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_MatchCase, MatchCase * %TBState_Checked Or %TBState_Enabled
      Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_WholeWords, WholeWords * %TBState_Checked Or %TBState_Enabled
   'Menus
    Menu Set State hPopupSettings, ByCmd %IDM_CustomMenu, CustomMenu * (%MFS_Checked Or %MFS_Enabled)
End Sub

Sub Settings_INI(Task$)
   Local x, y As Long, xResult, yResult, temp, INIFileName As WStringZ*%Max_Path
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "300", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "300", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult), Val(yResult)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "720", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "500", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult), Val(yResult)   'width/height

      'get value for string variables
      Getprivateprofilestring "All", "SearchString", "site", SearchString, %Max_Path, INIFileName
      Getprivateprofilestring "All", "FileName", Exe.Path$ + "files\tutorial_index.htm", FileName, %Max_Path, INIFileName

      'get value for numeric variables
      Getprivateprofilestring "All", "CustomMenu", "1", temp, %Max_Path, INIFileName:  CustomMenu = Val(temp)
      Getprivateprofilestring "All", "ExactString", "0", temp, %Max_Path, INIFileName:  ExactString = Val(temp)
      Getprivateprofilestring "All", "HighLight", "0", temp, %Max_Path, INIFileName:  HighLight = Val(temp)
      Getprivateprofilestring "All", "MatchCase", "0", temp, %Max_Path, INIFileName:  MatchCase = Val(temp)
      Getprivateprofilestring "All", "WholeWords", "0", temp, %Max_Path, INIFileName:  WholeWords = Val(temp)

   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save string variables
      WritePrivateProfileString "All", "SearchString",SearchString, INIFileName
      WritePrivateProfileString "All", "FileName",FileName, INIFileName

      'save numeric variables
      WritePrivateProfileString "All", "CustomMenu", (Str$(CustomMenu)), INIFileName
      WritePrivateProfileString "All", "ExactString", (Str$(ExactString)), INIFileName
      WritePrivateProfileString "All", "HighLight", (Str$(HighLight)), INIFileName
      WritePrivateProfileString "All", "MatchCase", (Str$(MatchCase)), INIFileName
      WritePrivateProfileString "All", "WholeWords", (Str$(WholeWords)), INIFileName

   End If
End Sub

Sub HighlightTerms
   Local pIWebBrowser2 As IWebBrowser2     'instance of the webbrowser control
   Local pIHTMLDocument As IHTMLDocument2
   Local pIHTMLSelectionObject As IHTMLSelectionObject
   Local pDispatch As IDispatch
   Local pIHTMLTxtRange As IHTMLTxtRange
   Local sTerm$,i,iRes, iCount As Long

   MousePtr 11

   'create object references
   pIWebBrowser2 = OC_GetDispatch(hBrowser) 'reference to webbrowser control default interface
   pIHTMLDocument = pIWebBrowser2.Document
   pIHTMLSelectionObject = pIHTMLDocument.selection
   pDispatch = pIHTMLSelectionObject.createRange
   pIHTMLTxtRange = pDispatch

   'get textbox content
    Control Get Text hDlg, %IDC_SearchString To SearchString
    If SearchString = "" Then
       Statusbar Set Text hDlg, %IDC_StatusBar, 1, 0, "No search terms found!"
       Beep
       Exit Sub
    End If
    If MatchCase Then sTerm$ = SearchString Else sTerm$ = LCase$(SearchString)

    'create search term list in array T(). don't always need it, but quick to create
    If ExactString Then
       ReDim T(0) As String
       T(0) = sTerm$
    Else
       While InStr(sTerm$, "  ") : Replace "  " With " " In sTerm$ : Wend       'remove double spaces
       sTerm$ = Trim$(sTerm$)                                                   'remove end spaces
       ReDim T(ParseCount(sTerm$, " ")-1) As String                             'create array of terms
       Parse sTerm$, T(), " "
    End If

    'highlight all terms
    For i = 0 To UBound(T)
       pIHTMLTxtRange.collapse(%VARIANT_FALSE)
       pIHTMLTxtRange.moveStart("character",-10000)
       iRes = pIHTMLTxtRange.findText(T(i), &H7FFFFFFF???, MatchCase * %FINDTEXT_Matchcase + WholeWords * %FINDTEXT_WholeWord)
       Do While iRes
          pIHTMLTxtRange.execCommand("BackColor", %VARIANT_TRUE, IIf$(Highlight,"Yellow","White"))
          pIHTMLTxtRange.collapse(%VARIANT_FALSE)
           iRes = pIHTMLTxtRange.findText(T(i), &H7FFFFFFF???, MatchCase * %FINDTEXT_Matchcase + WholeWords * %FINDTEXT_WholeWord)
          Incr iCount
       Loop While iRes
    Next i

    If Highlight Then
       Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, "Matching terms found: " + Str$(iCount)
    Else
       Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, ""
    End If
    MousePtr 1
End Sub


Sub GoToElement(Flag As Long, tmp$$)
   Local pIWebBrowser2 As IWebBrowser2
   Local pIHTMLDocument2 As IHTMLDocument2
   Local pIHTMLDocument3 As IHTMLDocument3

   Local Elems As IHTMLElementCollection
   Local E As IHTMLElement
   Local i,iResult As Long
   Local pIHTMLSelectionObject As IHTMLSelectionObject
   Local pDispatch As IDispatch
   Local pIHTMLTxtRangeE As IHTMLTxtRange
   Local pIHTMLTxtRangeS As IHTMLTxtRange

   hBrowser = GetDlgItem(hDlg,%IDC_Browser)
   pIWebBrowser2 = OC_GetDispatch(hBrowser) 'reference to webbrowser control default interface
   pIHTMLDocument2 = pIWebBrowser2.Document
   pIHTMLDocument3 = pIHTMLDocument2
   Elems = pIHTMLDocument3.GetElementsByTagName(tmp$$)
   pIHTMLSelectionObject = pIHTMLDocument2.selection
   pIHTMLTxtRangeS = pIHTMLSelectionObject.createRange  'used to store initial selection text trange
   pIHTMLTxtRangeE = pIHTMLSelectionObject.createRange  'used for element text ranges

   If Flag = %GoNext Then
      For i = 0 To Elems.Length - 1   'zero based element count
         pDispatch = Elems.item(i,i)
         E = pDispatch
         pIHTMLTxtRangeE.moveToElementText(E)
         iResult = pIHTMLTxtRangeE.compareEndPoints("EndToEnd", pIHTMLTxtRangeS)
         If iResult = 1 Then
            pIHTMLTxtRangeE.select
            E.scrollIntoView %Variant_True
            Exit For
         End If
      Next i
   Else
      For i = Elems.Length - 1 To 0 Step -1  'zero based element count
         pDispatch = Elems.item(i,i)
         E = pDispatch
         pIHTMLTxtRangeE.moveToElementText(E)
         iResult = pIHTMLTxtRangeE.compareEndPoints("EndToEnd", pIHTMLTxtRangeS)
         If iResult = -1 Then
            pIHTMLTxtRangeE.select
            E.scrollIntoView %Variant_True
            Exit For
         End If
      Next i
   End If
End Sub

Sub OpenSearchDialog
   Local pIWebBrowser2 As IWebBrowser2
   Local CGID_WebBrowser As Guid
   Local pDisp As IDispatch
   Local pCmdTarget As IOleCommandTarget
   Local vIn As Variant
   Local vOut As Variant

   CGID_WebBrowser = Guid$("{ED016940-BD5B-11CF-BA4E-00C04FD70816}")
   pIWebBrowser2 = OC_GetDispatch(hBrowser)
   pDisp = pIWebBrowser2.Document
   If IsObject(pDisp) Then
      pCmdTarget = pDisp
      If IsObject(pCmdTarget) Then
         pCmdTarget.Exec(CGID_WebBrowser, 1, 0, vIn, vOut)
      End If
   End If
End Sub

Sub GoToPosition(x As Long, y As Long)
   Local pIWebBrowser2 As IWebBrowser2
   Local pIHTMLDocument2 As IHTMLDocument2
   Local pIHTMLWindow2 As IHTMLWindow2
   pIWebBrowser2 = OC_GetDispatch(hBrowser) 'reference to webbrowser control default interface
   pIHTMLDocument2 = pIWebBrowser2.Document
   pIHTMLWindow2 = pIHTMLDocument2.parentWindow
   pIHTMLWindow2.ScrollTo(x,y)
End Sub

Function InputBoxProcIndent(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
   Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
   If nCode < 0 Then Exit Function
   If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
   If nCode = %HCBT_CREATEWND Then
      cw = lParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
      cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
      GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
      If UCase$(szTemp) = "BUTTON" Then @cst.x = 120  : @cst.cx = 60           'ok and cancel
      If UCase$(szTemp) = "STATIC" Then @cst.x = 400                           'prompt
      If UCase$(szTemp) = "EDIT"   Then @cst.cx = 100 : @cst.y = @cst.y - 130  'textbox
      If UCase$(szTemp) = "EDIT"   Then SetWindowLong wparam, %GWL_Style, GetWindowLong(wParam,%GWL_Style)
      If UCase$(szTemp) = "#32770" Then @cst.cx = 200 : @cst.cy = @cst.cy - 130                'dialog
   End If
End Function

Sub GoToChapter   'go to user-specified Chapter
   Local i,w,h As Long, temp$
   'ask for chapter #
   Dialog Get Loc hDlg To w,h
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProcIndent), GetModuleHandle(""), GetCurrentThreadId)
   temp$ = InputBox$("", "Go To Chapter", Str$(LastChapter), w+40,h+150)
   If Len(temp$) = 0 Then Exit Sub
   If Val(temp$) < 0 Then Exit Sub
   LastChapter = Val(temp$)-1                'zero based

   Local pIWebBrowser2 As IWebBrowser2
   Local pIHTMLDocument2 As IHTMLDocument2
   Local pIHTMLDocument3 As IHTMLDocument3

   Local Elems As IHTMLElementCollection
   Local E As IHTMLElement

   Local pIHTMLSelectionObject As IHTMLSelectionObject
   Local pDispatch As IDispatch
   Local pIHTMLTxtRangeE As IHTMLTxtRange

   hBrowser = GetDlgItem(hDlg,%IDC_Browser)
   pIWebBrowser2 = OC_GetDispatch(hBrowser) 'reference to webbrowser control default interface
   pIHTMLDocument2 = pIWebBrowser2.Document
   pIHTMLDocument3 = pIHTMLDocument2
   Elems = pIHTMLDocument3.GetElementsByTagName("h2")
   pIHTMLSelectionObject = pIHTMLDocument2.selection
   pIHTMLTxtRangeE = pIHTMLSelectionObject.createRange  'used for element text ranges

   If LastChapter > Elems.length-1 Then Exit Sub

   pDispatch = Elems.item(LastChapter,i)
   E = pDispatch
   pIHTMLTxtRangeE.moveToElementText(E)
   E.scrollIntoView %Variant_True
End Sub

Sub SelectFile
    Local title$, startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
    title$ = ""    'caption title. if "", then "Open" is displayed
    filter$ = "HTML Files" + $Nul + "*.htm" + $Nul   ' or filter$ = CHR$("Text",0,"*.txt",0)
    startfolder$ = IIf$(Len(FileName), FileName, Exe.Path$)     'initial folder to be displayed
    startfile$ = (FileName)       'name to be used as initial selection
    flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
    Display Openfile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then
       FileName = filevar$
       Control Set Text hDlg, %IDC_FileName, FileName
       DisplayFileInBrowser
    End If
End Sub

Sub DisplayFileInBrowser
   Local WB As IWebBrowser2
   Local vVar As Variant
   If Left$(LCase$(FileName),4) <> "http" Then
      If IsFalse(IsFile(FileName)) Then Exit Sub
      vVar = "file:///" + FileName
   End If
   WB = OC_GetDispatch(hBrowser)
   WB.Navigate2(vVar)
End Sub

Sub ClearBrowser
   Local WB As IWebBrowser2
   Local vVar As Variant
   vVar = "about:blank"
   WB = OC_GetDispatch(hBrowser)
   WB.Navigate2(vVar)
End Sub

Sub UnHighlightAll
   Local pIWebBrowser2 As IWebBrowser2     'instance of the webbrowser control
   Local pIHTMLDocument As IHTMLDocument2
   Local pIHTMLSelectionObject As IHTMLSelectionObject
   Local pDispatch As IDispatch
   Local pIHTMLTxtRange As IHTMLTxtRange

   pIWebBrowser2 = OC_GetDispatch(hBrowser) 'reference to webbrowser control default interface
   pIHTMLDocument = pIWebBrowser2.Document
   pIHTMLSelectionObject = pIHTMLDocument.selection
   pDispatch = pIHTMLSelectionObject.createRange
   pIHTMLTxtRange = pDispatch
   pIHTMLTxtRange.moveEnd("character",&H7FFFFFFF???)
   pIHTMLTxtRange.moveStart("character",-1 * &H7FFFFFFF???)
   pIHTMLTxtRange.execCommand("BackColor", %VARIANT_TRUE, "White")
End Sub

Sub CopySelection
   Local pIWebBrowser2 As IWebBrowser2
   Local pIHTMLDocument2 As IHTMLDocument2
   Local pIHTMLSelectionObject As IHTMLSelectionObject
   Local pDispatch As IDispatch
   Local pIHTMLTxtRange As IHTMLTxtRange

   pIWebBrowser2 = OC_GetDispatch(hBrowser) 'reference to webbrowser control default interface
   pIHTMLDocument2 = pIWebBrowser2.Document
   pIHTMLSelectionObject = pIHTMLDocument2.selection
   pDispatch = pIHTMLSelectionObject.createRange
   pIHTMLTxtRange = pDispatch
   Clipboard Reset
   Clipboard Set Text pIHTMLTxtRange.text
End Sub

Sub CopyAll
   Local pIWebBrowser2 As IWebBrowser2
   Local pIHTMLDocument2 As IHTMLDocument2
   pIWebBrowser2 = OC_GetDispatch(hBrowser)
   pIHTMLDocument2 = pIWebBrowser2.Document
   Clipboard Reset
   Clipboard Set Text pIHTMLDocument2.body.innerText
End Sub

Class CDocHostUIHandler2 As Common   ' // Use AS COMMON to avoid removal of methods
   Interface IDocHostUIHandler2Impl $IID_IDocHostUIHandler2
      Inherit IUnknown

      Method ShowContextMenu (ByVal dwID As Dword, ByRef ppt As Point, ByVal pcmdtReserved As IUnknown, ByVal pdispReserved As IDispatch) As Long
         If CustomMenu Then
            TrackPopupMenu hPopupBrowser, %TPM_LeftAlign, ppt.x, ppt.y, 0, hDlg, ByVal 0
            Method = %S_Ok
         Else
            Method = %S_False
         End If
      End Method

      Method GetHostInfo (ByRef pInfo As DOCHOSTUIINFO) As Long
         If VarPtr(pInfo) Then
            pInfo.cbSize = SizeOf(DOCHOSTUIINFO)
            pInfo.dwFlags = %DOCHOSTUIFLAG_NO3DBORDER Or %DOCHOSTUIFLAG_THEME
            pInfo.dwDoubleClick = %DOCHOSTUIDBLCLK_DEFAULT
            pInfo.pchHostCss = %NULL
            pInfo.pchHostNS = %NULL
         End If
         Method = %S_Ok
      End Method

      Method ShowUI (ByVal dwID As Dword, ByVal pActiveObject As IOleInPlaceActiveObject, ByVal pCommandTarget As IOleCommandTarget _
                     , ByVal pFrame As IOleInPlaceFrame, ByVal pDoc As IOleInPlaceUIWindow) As Long : End Method
      Method HideUI () As Long : End Method
      Method UpdateUI () As Long : End Method
      Method EnableModeless (ByVal fEnable As Long) As Long : End Method
      Method OnDocWindowActivate (ByVal fActivate As Long) : End Method
      Method OnFrameWindowActivate (ByVal fActivate As Long) As Long : End Method
      Method ResizeBorder (ByRef prcBorder As RECT, ByVal pUIWindow As IOleInPlaceUIWindow, ByVal fRameWindow As Long) As Long : End Method

      Method TranslateAccelerator (ByRef lpMsg As tagMSG, ByRef pguidCmdGroup As Guid, ByVal nCmdID As Dword) As Long
         Method = %S_False
      End Method

      Method GetOptionKeyPath (ByRef pchKey As Dword,ByVal dw_ As Dword) As Long
         pchKey = %NULL
      End Method

      Method GetDropTarget (ByVal pDropTarget As IDropTarget, ByRef ppDropTarget As IDropTarget) As Long
         ppDropTarget = Nothing
         Method = %E_NotImpl
      End Method

      Method GetExternal (ByRef ppDispatch As IDispatch) As Long
         ppDispatch = Nothing
         Method = %S_False
      End Method

      Method TranslateUrl (ByVal dwTranslate As Dword, ByRef pchURLIn As WStringZ, ByRef ppchURLOut As WStringZ) As Long
         ppchURLOut = ""
         Method = %S_False
      End Method

      Method FilterDataObject (ByVal pDO As IDataObject, ByRef ppDORet As IDataObject) As Long
         ppDORet = Nothing
         Method = %S_False
      End Method

      Method GetOverrideKeyPath (ByRef pchKey As Dword, ByVal dw_ As Dword) As Long
         pchKey = %NULL
      End Method
   End Interface
End Class

Class CDWebBrowserEvents2 As Event
   Interface DWebBrowserEvents2Impl $IID_DWebBrowserEvents2 As Event
      Inherit IDispatch
      Method DocumentComplete <259> (ByVal pDisp As IDispatch, ByRef vURL As Variant)
         Local pIWebBrowser2 As IWebBrowser2
         Local pIHTMLDocument2 As IHTMLDocument2
         Local pICustomDoc As ICustomDoc
         Local pDocHostUIHandler As IDocHostUIHandler2Impl
         pIWebBrowser2 = pDisp
         pIHTMLDocument2 = pIWebBrowser2.Document
         pICustomDoc = pIHTMLDocument2
         pDocHostUIHandler = Class "CDocHostUIHandler2"
         pICustomDoc.SetUIHandler(pDocHostUIHandler)
         If Highlight Then HighLightTerms
      End Method
   End Interface
End Class
